Subject: [Lsvr] Need clarification on IGP-Metric TLV for LS Link Attributes in BGP-SPF deployments

From: Pushpasis Sarkar <[email-masked]>
Date: Mon, 9 Mar 2020 21:00:55 +0530

Hi Authors,

I need a small clarification on how the Link IGP-Metric TLV (type 1095) for
the links originated by an BGP-SPF speaker look like. My doubt is
specifically on what would be the length of the metric value. For example,
following is the excerpt from RFC7752 section 3.3.2.4 which specifies the
length to be 1, 2 or 3 bytes for ISIS narrow-metrics, OSPF and ISIS
wide-metrics.

3.3.2.4.  IGP Metric TLV

   The IGP Metric TLV carries the metric for this link.  The length of
   this TLV is variable, depending on the metric width of the underlying
   protocol.  IS-IS small metrics have a length of 1 octet (the two most
   significant bits are ignored).  OSPF link metrics have a length of 2
   octets.  IS-IS wide metrics have a length of 3 octets.

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |              Type             |             Length            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     //      IGP Link Metric (variable length)      //
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

                     Figure 21: IGP Metric TLV Format

What should be the length of the metric field when the origin is a BGP-SPF
speaker?

Looking forward to your clarification on this. Also it will be appreciated
a lot if a sentence or two can be added to the draft clarifying the above
in the next version.

Thanks and regards,
-Pushpasis

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Fri, 20 Mar 2020 18:40:09 +0000

Hi Pushpasis,
I think for BGP-LS SPF we should always use 3 octet metrics. This will offer the most flexibility w/o redefining the TLV. If you agree, I will update the SPF draft to state this.
Thanks,
Acee

From: Pushpasis Sarkar <[email-masked]>
Date: Monday, March 9, 2020 at 11:31 AM
To: "[email-masked]" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: Need clarification on IGP-Metric TLV for LS Link Attributes in BGP-SPF deployments
Resent-From: <[email-masked]>
Resent-To: Keyur Patel <[email-masked]>, Acee Lindem <[email-masked]>, Shawn Zandi <[email-masked]>, Wim Henderickx <[email-masked]>
Resent-Date: Monday, March 9, 2020 at 11:31 AM

Hi Authors,

I need a small clarification on how the Link IGP-Metric TLV (type 1095) for the links originated by an BGP-SPF speaker look like. My doubt is specifically on what would be the length of the metric value. For example, following is the excerpt from RFC7752 section 3.3.2.4 which specifies the length to be 1, 2 or 3 bytes for ISIS narrow-metrics, OSPF and ISIS wide-metrics.

3.3.2.4.  IGP Metric TLV

      0                   1                   2                   3

     |              Type             |             Length            |

What should be the length of the metric field when the origin is a BGP-SPF speaker?

Looking forward to your clarification on this. Also it will be appreciated a lot if a sentence or two can be added to the draft clarifying the above in the next version.

Thanks and regards,
-Pushpasis

---

From: Pushpasis Sarkar <[email-masked]>
Date: Sat, 21 Mar 2020 18:30:00 +0530

Hi Acee,

My personal preference will be having it as a 4-byte metric due to ease of
implementation as well as encoding/decoding efficiency due word-size
alignment. It may not be a big thing but encoding/decoding a 3-byte value
to/from byte stream is few more CPU instructions than just a 4-byte read
from a memory address.

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 12:10 AM Acee Lindem (acee) <[email-masked]> wrote:

> Hi Pushpasis,
>
> I think for BGP-LS SPF we should always use 3 octet metrics. This will
> offer the most flexibility w/o redefining the TLV. If you agree, I will
> update the SPF draft to state this.
>
> Thanks,
>
> Acee
>
>
>
> *From: *Pushpasis Sarkar <[email-masked]>
> *Date: *Monday, March 9, 2020 at 11:31 AM
> *To: *"[email-masked]" <[email-masked]
> >
> *Cc: *"[email-masked]" <[email-masked]>
> *Subject: *Need clarification on IGP-Metric TLV for LS Link Attributes in
> BGP-SPF deployments
> *Resent-From: *<[email-masked]>
> *Resent-To: *Keyur Patel <[email-masked]>, Acee Lindem <[email-masked]>,
> Shawn Zandi <[email-masked]>, Wim Henderickx <
> [email-masked]>
> *Resent-Date: *Monday, March 9, 2020 at 11:31 AM
>
>
>
> Hi Authors,
>
>
>
> I need a small clarification on how the Link IGP-Metric TLV (type 1095)
> for the links originated by an BGP-SPF speaker look like. My doubt is

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Sat, 21 Mar 2020 13:46:43 +0000

Hi Pushpasis,
If we use a length of 4, we’d need a new TLV (or modify RFC 7752). I think the former would be a better option.
Thanks,
Acee

From: Pushpasis Sarkar <[email-masked]>
Date: Saturday, March 21, 2020 at 9:00 AM
To: Acee Lindem <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: Need clarification on IGP-Metric TLV for LS Link Attributes in BGP-SPF deployments
Resent-From: <[email-masked]>
Resent-To: Keyur Patel <[email-masked]>, Acee Lindem <[email-masked]>, Shawn Zandi <[email-masked]>, Wim Henderickx <[email-masked]>
Resent-Date: Saturday, March 21, 2020 at 9:00 AM

Hi Acee,

My personal preference will be having it as a 4-byte metric due to ease of implementation as well as encoding/decoding efficiency due word-size alignment. It may not be a big thing but encoding/decoding a 3-byte value to/from byte stream is few more CPU instructions than just a 4-byte read from a memory address.

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 12:10 AM Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Pushpasis,
I think for BGP-LS SPF we should always use 3 octet metrics. This will offer the most flexibility w/o redefining the TLV. If you agree, I will update the SPF draft to state this.
Thanks,
Acee

From: Pushpasis Sarkar <[email-masked]<mailto:[email-masked]>>
Date: Monday, March 9, 2020 at 11:31 AM
To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Cc: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: Need clarification on IGP-Metric TLV for LS Link Attributes in BGP-SPF deployments
Resent-From: <[email-masked]<mailto:[email-masked]>>
Resent-To: Keyur Patel <[email-masked]<mailto:[email-masked]>>, Acee Lindem <[email-masked]<mailto:[email-masked]>>, Shawn Zandi <[email-masked]<mailto:[email-masked]>>, Wim Henderickx <[email-masked]<mailto:[email-masked]>>
Resent-Date: Monday, March 9, 2020 at 11:31 AM

Hi Authors,

3.3.2.4.  IGP Metric TLV

      0                   1                   2                   3

     |              Type             |             Length            |

Thanks and regards,
-Pushpasis

---

From: Pushpasis Sarkar <[email-masked]>
Date: Sat, 21 Mar 2020 19:45:03 +0530

Hi Acee,

I thought RFC7752 says it is a variable length TLV. 1-byte, 2-byte, and
3-byte metrics are possible lengths. Can't we add a 4th possible length via
this draft? If not then a new TLV may be a better option.

However if I remember correctly, there is a RFC7752 bis being worked upon.
Is there an option we can add it in that document? Not sure if it will be a
proper way or not. Just thinking out loud :)

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 7:17 PM Acee Lindem (acee) <[email-masked]> wrote:

> *Date: *Saturday, March 21, 2020 at 9:00 AM
> *To: *Acee Lindem <[email-masked]>
> *Cc: *"[email-masked]" <[email-masked]>,
> "[email-masked]" <[email-masked]>
> *Subject: *Re: Need clarification on IGP-Metric TLV for LS Link
> Attributes in BGP-SPF deployments
> *Resent-Date: *Saturday, March 21, 2020 at 9:00 AM
>
>
>
> Hi Acee,
>
>
>

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Sat, 21 Mar 2020 14:19:25 +0000

Hi Pushpais,
I think we can get away with this w/o modifying RFC 7752 since, as you noted, it just says it is variable.
Thanks,
Acee

Date: Saturday, March 21, 2020 at 10:15 AM

Hi Acee,

I thought RFC7752 says it is a variable length TLV. 1-byte, 2-byte, and 3-byte metrics are possible lengths. Can't we add a 4th possible length via this draft? If not then a new TLV may be a better option.

However if I remember correctly, there is a RFC7752 bis being worked upon. Is there an option we can add it in that document? Not sure if it will be a proper way or not. Just thinking out loud :)

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 7:17 PM Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Pushpasis,
If we use a length of 4, we’d need a new TLV (or modify RFC 7752). I think the former would be a better option.
Thanks,
Acee

From: Pushpasis Sarkar <[email-masked]<mailto:[email-masked]>>
Date: Saturday, March 21, 2020 at 9:00 AM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>
Cc: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: Re: Need clarification on IGP-Metric TLV for LS Link Attributes in BGP-SPF deployments
Resent-From: <[email-masked]<mailto:[email-masked]>>
Resent-To: Keyur Patel <[email-masked]<mailto:[email-masked]>>, Acee Lindem <[email-masked]<mailto:[email-masked]>>, Shawn Zandi <[email-masked]<mailto:[email-masked]>>, Wim Henderickx <[email-masked]<mailto:[email-masked]>>
Resent-Date: Saturday, March 21, 2020 at 9:00 AM

Hi Acee,

Thanks
-Pushpasis

Hi Authors,

3.3.2.4.  IGP Metric TLV

      0                   1                   2                   3

     |              Type             |             Length            |

Thanks and regards,
-Pushpasis

---

From: Pushpasis Sarkar <[email-masked]>
Date: Sun, 22 Mar 2020 21:13:15 +0530

Hi Acee,

Sure. If anyone doesn't prefer any other way we can proceed with this.

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 7:49 PM Acee Lindem (acee) <[email-masked]> wrote:

> *Date: *Saturday, March 21, 2020 at 10:15 AM

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Tue, 24 Mar 2020 14:47:44 +0000

Hi Pushpasis, et al,
This is clarified in the -08 version of the draft.
Thanks,
Acee

Date: Sunday, March 22, 2020 at 11:43 AM

Hi Acee,

Thanks
-Pushpasis

On Sat, Mar 21, 2020 at 7:49 PM Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Pushpais,
I think we can get away with this w/o modifying RFC 7752 since, as you noted, it just says it is variable.
Thanks,
Acee

Hi Acee,

Thanks
-Pushpasis

Hi Acee,

Thanks
-Pushpasis

Hi Authors,

3.3.2.4.  IGP Metric TLV

      0                   1                   2                   3

     |              Type             |             Length            |

Thanks and regards,
-Pushpasis

---

From: Pushpasis Sarkar <[email-masked]>
Date: Fri, 27 Mar 2020 01:58:23 +0530

Hi Acee,

Thanks a lot for taking care of this.

Best regards
-Pushpasis

On Tue, Mar 24, 2020 at 8:18 PM Acee Lindem (acee) <[email-masked]> wrote:

> *Date: *Sunday, March 22, 2020 at 11:43 AM